<template>
  <div class="base-layout">
    <TheHeader />
    <slot />
    <ButtonScrollToTop v-show="scrolled" />
    <TheFooter />
  </div>
</template>

<script>
import TheHeader from '@/components/layout/TheHeader'
import TheFooter from '@/components/layout/TheFooter'
import ButtonScrollToTop from '@/components/shared/ButtonScrollToTop'

import debounce from 'lodash/debounce'
import { ref } from 'vue'

export default {
  name: 'BaseLayout',
  components: {
    TheHeader,
    TheFooter,
    ButtonScrollToTop
  },
  setup() {
    const scrolled = ref(false)
    const handleScroll = () => {
      scrolled.value =
        window.pageYOffset > document.documentElement.clientHeight
    }

    window.addEventListener('scroll', debounce(handleScroll, 100))

    return { scrolled }
  }
}
</script>
